#include <stdio.h>
#include <stdlib.h>
#include <string>

#ifndef rti_me_cpp_hxx
#include "rti_me_cpp.hxx"
#endif

#include "HelloWorldApplication.h"
#include "HelloWorldPlugin.h"
#include "HelloWorldSupport.h"

#include "dds_cpp/dds_cpp_dpde.hxx"
#include "dds_cpp/dds_cpp_wh_sm.hxx"
#include "dds_cpp/dds_cpp_rh_sm.hxx"
#include "dds_cpp/dds_cpp_netio.hxx"


/* Include header file for Built-in DDS Security Plugins CPP API */
#include "sec_core/sec_core_cpp.h"

const char *ca_string = "data:,-----BEGIN CERTIFICATE-----\n"
"MIIDjjCCAnYCCQD5TfiGhELqHzANBgkqhkiG9w0BAQsFADCBiDELMAkGA1UEBhMC\n"
"VVMxCzAJBgNVBAgMAkNBMRIwEAYDVQQHDAlTdW5ueXZhbGUxGDAWBgNVBAoMD015\n"
"IE9yZ2FuaXphdGlvbjESMBAGA1UEAwwJTXkgT3JnIENBMSowKAYJKoZIhvcNAQkB\n"
"FhtleGFtcGxlQG15LW9yZ2FuaXphdGlvbi5jb20wHhcNMTkwOTEwMjAzOTM2WhcN\n"
"MjkwOTA3MjAzOTM2WjCBiDELMAkGA1UEBhMCVVMxCzAJBgNVBAgMAkNBMRIwEAYD\n"
"VQQHDAlTdW5ueXZhbGUxGDAWBgNVBAoMD015IE9yZ2FuaXphdGlvbjESMBAGA1UE\n"
"AwwJTXkgT3JnIENBMSowKAYJKoZIhvcNAQkBFhtleGFtcGxlQG15LW9yZ2FuaXph\n"
"dGlvbi5jb20wggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQDdymMoRZYY\n"
"PHqZ5HdBdu3hKSdvEWTCKSP3DG8kghH8Ie11U1Cs4Hs+UWmEi/rz7uB97Az5hc88\n"
"uvJyFyvzzZX3FR+G7nQfB7mpfuE1FM5ERVKzkCFuLX8dVZz0h+88NrWsQVSCD9F0\n"
"WsaNBE/v7oQXwiLfdTbpoi3bWEV6y8sZ5BIJ/BZq3x/HTZcFjv3Wv0fAFIMxNspo\n"
"l1eXW4qnmnNPQBGvMSyLcd3fNwLVXkuzZYxA/CDymSfnFpMLVtFKeS0p3XrM5mnh\n"
"lfLJL3gfK4dxmNG3ACImopAXAfFRJZDncNBkDUY+SZp7TyPsRB50ZsvkOAZdbJ8A\n"
"26MU5YhfzU5tAgMBAAEwDQYJKoZIhvcNAQELBQADggEBAHRB0RbHSQ3LtOxlhi//\n"
"/jT1+t46UDawX4jD2T8g79qdfAS57fidWCN3tmIbirvAiC8A0gl7pDN1HT4raDRK\n"
"94SsL9sFFpvBtoYWmxGsmyAlQ6k5jzTnqzlFwgfPOr2vvVG63OQXXasPtzKNb96X\n"
"qqtU8HPFI2NeLDI1XNutJOH5EjJsOukV5t/0jh6QQB4heFYZPrwlWqCfxMGCQU9/\n"
"Dc9oQafTrKxLFbqLUUS+ItJWNDEjcu8idtFn41OQlYCubYYZN9inaGhz42sv50sK\n"
"03OgruLuTZ5qx/qvyfPzjfrK7XWgxZYaBkU1mVgzeH1TBkVXvmhRBFc7p1RcAo1J\n"
"FTE=\n"
"-----END CERTIFICATE-----";

const char *subscriber_string = "data:,Certificate:\n"
"    Data:\n"
"        Version: 1 (0x0)\n"
"        Serial Number: 2 (0x2)\n"
"    Signature Algorithm: sha256WithRSAEncryption\n"
"        Issuer: C=US, ST=CA, L=Sunnyvale, O=My Organization, CN=My Org CA/emailAddress=example@my-organization.com\n"
"        Validity\n"
"            Not Before: Sep 10 20:39:36 2019 GMT\n"
"            Not After : Sep  9 20:39:36 2020 GMT\n"
"        Subject: C=US, ST=CA, O=My Organization, CN=A subscriber/emailAddress=subscriber@my-organization.com\n"
"        Subject Public Key Info:\n"
"            Public Key Algorithm: rsaEncryption\n"
"                Public-Key: (2048 bit)\n"
"                Modulus:\n"
"                    00:bd:8f:20:3e:16:43:02:2b:26:a8:c1:ff:e9:b8:\n"
"                    cc:56:28:0d:1b:02:7c:f3:22:32:05:5b:2e:a5:42:\n"
"                    c1:e9:33:3e:fe:34:1b:8a:c6:44:19:a5:a0:80:1b:\n"
"                    b3:75:08:05:52:32:38:50:b0:63:db:42:b4:00:d8:\n"
"                    23:bb:4d:af:eb:45:9b:00:dd:f2:87:29:e6:1e:ac:\n"
"                    a9:b3:dd:11:5c:f7:d8:b3:39:b3:0e:c0:c8:fa:a6:\n"
"                    36:40:8d:38:37:37:b2:eb:7b:d2:54:c8:51:42:d3:\n"
"                    3e:c3:07:56:fa:82:2d:18:ab:3c:22:8e:1b:20:a0:\n"
"                    a4:16:e4:27:1d:5f:60:d7:96:7e:ae:90:76:a0:25:\n"
"                    ec:8b:dc:5e:73:6f:ae:08:c0:02:e3:c4:f9:bc:54:\n"
"                    46:8d:38:3b:72:86:a3:06:5f:92:c6:6a:9c:9c:9a:\n"
"                    71:80:77:aa:fa:d9:6b:02:ec:17:e6:44:f9:d0:99:\n"
"                    90:be:ec:cb:8d:a1:d9:2a:08:3d:f3:4b:95:47:38:\n"
"                    9b:90:2c:89:68:c9:14:32:e1:ff:31:81:79:24:86:\n"
"                    46:26:75:e5:fb:13:44:f0:e0:4c:26:8c:97:ff:2e:\n"
"                    fc:41:ab:af:3b:81:eb:fe:62:9d:c9:7c:1b:a5:55:\n"
"                    d0:79:72:76:f7:a1:8f:1d:96:e3:e4:f7:48:4b:a1:\n"
"                    78:d7\n"
"                Exponent: 65537 (0x10001)\n"
"    Signature Algorithm: sha256WithRSAEncryption\n"
"         8b:0e:99:e3:5c:40:33:93:14:e6:4d:17:4c:8e:8d:bb:fb:40:\n"
"         70:e8:7b:1e:2d:bb:e7:42:34:b0:18:b9:7a:3c:0b:4a:5f:68:\n"
"         ab:bb:57:85:b3:df:83:8d:f4:19:57:6c:56:e7:73:b2:35:0a:\n"
"         27:80:6d:82:69:5f:29:36:c5:ec:95:0a:47:33:e4:fe:b4:da:\n"
"         4f:a4:10:10:b0:5d:a8:e1:45:e8:0f:08:51:fb:04:fb:f8:25:\n"
"         3e:99:41:b9:d2:b0:ea:ea:87:27:78:4c:6e:24:f3:46:9c:fc:\n"
"         53:71:3d:55:25:98:d0:36:13:00:fc:81:57:39:39:2f:a9:53:\n"
"         bd:91:41:9b:1e:79:94:ad:df:85:c6:07:95:aa:5a:5c:c4:6d:\n"
"         d1:c6:67:68:67:6f:bf:a3:9e:e7:76:c9:86:bc:c4:aa:77:18:\n"
"         f1:ba:45:ea:84:9c:c5:5a:e6:18:a2:c7:af:04:9a:41:be:75:\n"
"         e7:62:09:ff:91:c1:eb:fa:1c:fd:8b:67:b7:9a:eb:34:47:c7:\n"
"         e1:1a:9a:91:a7:41:22:b0:38:e8:99:d9:d9:2e:74:ed:ea:da:\n"
"         66:01:c1:8c:1b:72:22:b0:ea:4a:f0:0a:4a:00:14:3a:34:ba:\n"
"         2f:1d:38:54:f0:9e:1d:d8:05:7b:52:04:59:ca:23:98:aa:8d:\n"
"         d5:43:e5:7c\n"
"-----BEGIN CERTIFICATE-----\n"
"MIIDdzCCAl8CAQIwDQYJKoZIhvcNAQELBQAwgYgxCzAJBgNVBAYTAlVTMQswCQYD\n"
"VQQIDAJDQTESMBAGA1UEBwwJU3Vubnl2YWxlMRgwFgYDVQQKDA9NeSBPcmdhbml6\n"
"YXRpb24xEjAQBgNVBAMMCU15IE9yZyBDQTEqMCgGCSqGSIb3DQEJARYbZXhhbXBs\n"
"ZUBteS1vcmdhbml6YXRpb24uY29tMB4XDTE5MDkxMDIwMzkzNloXDTIwMDkwOTIw\n"
"MzkzNlowejELMAkGA1UEBhMCVVMxCzAJBgNVBAgMAkNBMRgwFgYDVQQKDA9NeSBP\n"
"cmdhbml6YXRpb24xFTATBgNVBAMMDEEgc3Vic2NyaWJlcjEtMCsGCSqGSIb3DQEJ\n"
"ARYec3Vic2NyaWJlckBteS1vcmdhbml6YXRpb24uY29tMIIBIjANBgkqhkiG9w0B\n"
"AQEFAAOCAQ8AMIIBCgKCAQEAvY8gPhZDAismqMH/6bjMVigNGwJ88yIyBVsupULB\n"
"6TM+/jQbisZEGaWggBuzdQgFUjI4ULBj20K0ANgju02v60WbAN3yhynmHqyps90R\n"
"XPfYszmzDsDI+qY2QI04Nzey63vSVMhRQtM+wwdW+oItGKs8Io4bIKCkFuQnHV9g\n"
"15Z+rpB2oCXsi9xec2+uCMAC48T5vFRGjTg7coajBl+SxmqcnJpxgHeq+tlrAuwX\n"
"5kT50JmQvuzLjaHZKgg980uVRzibkCyJaMkUMuH/MYF5JIZGJnXl+xNE8OBMJoyX\n"
"/y78QauvO4Hr/mKdyXwbpVXQeXJ296GPHZbj5PdIS6F41wIDAQABMA0GCSqGSIb3\n"
"DQEBCwUAA4IBAQCLDpnjXEAzkxTmTRdMjo27+0Bw6HseLbvnQjSwGLl6PAtKX2ir\n"
"u1eFs9+DjfQZV2xW53OyNQongG2CaV8pNsXslQpHM+T+tNpPpBAQsF2o4UXoDwhR\n"
"+wT7+CU+mUG50rDq6ocneExuJPNGnPxTcT1VJZjQNhMA/IFXOTkvqVO9kUGbHnmU\n"
"rd+FxgeVqlpcxG3RxmdoZ2+/o57ndsmGvMSqdxjxukXqhJzFWuYYosevBJpBvnXn\n"
"Ygn/kcHr+hz9i2e3mus0R8fhGpqRp0EisDjomdnZLnTt6tpmAcGMG3IisOpK8ApK\n"
"ABQ6NLovHThU8J4d2AV7UgRZyiOYqo3VQ+V8\n"
"-----END CERTIFICATE-----";

const char *subscriber_key_string = "data:,-----BEGIN RSA PRIVATE KEY-----\n"
"MIIEpAIBAAKCAQEAvY8gPhZDAismqMH/6bjMVigNGwJ88yIyBVsupULB6TM+/jQb\n"
"isZEGaWggBuzdQgFUjI4ULBj20K0ANgju02v60WbAN3yhynmHqyps90RXPfYszmz\n"
"DsDI+qY2QI04Nzey63vSVMhRQtM+wwdW+oItGKs8Io4bIKCkFuQnHV9g15Z+rpB2\n"
"oCXsi9xec2+uCMAC48T5vFRGjTg7coajBl+SxmqcnJpxgHeq+tlrAuwX5kT50JmQ\n"
"vuzLjaHZKgg980uVRzibkCyJaMkUMuH/MYF5JIZGJnXl+xNE8OBMJoyX/y78Qauv\n"
"O4Hr/mKdyXwbpVXQeXJ296GPHZbj5PdIS6F41wIDAQABAoIBAQCbO2tXDNoBG59E\n"
"EeLl3p0PbSsWVFpIrVczRbGUSnAL7hiHCdsIMUcxjY47evPiQhhBcLjncxvDQgOw\n"
"sU/JolwPGmhONHPZNnmp4xHyJnaCoMEIPJci3MN5Z8YD5OIFbgqKh1L+dTD+vYmn\n"
"IwqaiSIvEoNjdOZIOOVHjb1uc14WDVJB2vIqYwXSY2UxCbCaJV8Mod9Tu+T5OOYx\n"
"lVHNoTicGdO39QMZ8+HMwp1g/jmFebyYDNNYdr/bYB6u5aVlWSuhtdO68SWoEpKE\n"
"c4g9wmlsbAtBqX9c2rn1pdwSJOj+84stL+flEHuQp/E2fPfWZeJZqvWJogdWIAwl\n"
"m8aCzEThAoGBAOWrfpqkRaRWqtwqrHlsRw0yZuXCFAFG/jzgPhySXof+63FVCb+5\n"
"YlUd6MDaWSjN5ehUBMo99AwEhlWfKe9evFsi2V2Z6uJfqk2OK8pDRzlj49tHcB8l\n"
"d00C5BpxMeVl8VHMapzsTFSEe9hOn0xlUAAY3oHuNLicQlKOJbkWr6eRAoGBANNK\n"
"brT0T11FIjV2Ls27rE2IMEqMSGyEMaZVhB6WS5rzSuj35L73ghx2e9ZzGhza486U\n"
"RFF7A3XEauGYyR4ID9Nql+5fBSR3SCNtzeVcdWkDeov3eYK1OH3Pxd//qAXqnnF/\n"
"CEGDZViBzFFWo3G6ZxH9jnYP2jV6wWctzoLEzHXnAoGACw51etZbr+yoLw8y3GmV\n"
"BhKeF4N/WQxk4uNcuh1lxaBFD2CrpnozPKvC773TOv6mice5r07KN+Xj3a1a5HYo\n"
"FS8ZTcNCJoG6fh9RBly0yhN//adzw1wXYTK5bnhykXuV4X04yLMrfYofOCuYyaG6\n"
"9zY7SAACs7x6COVk9YMdE7ECgYBsPGDhyZUuTk/r2xK2yUDGptE2Hw6qqD1W28/G\n"
"a29nfOIO3Y4MVXYNZpShkmz6AxdXp5QnuUBYf7nQvxenjrGst5oEviBAQepuW71x\n"
"lR+AIAwSzz8rufGqYVkYGjrUbQ+lTFHKXaj44eTsddlcVQSfrqffytcZNj0Ewe5c\n"
"BrxGWQKBgQC58jETxWCCTCIs22fUWPCNFcPmzTmtLN9+8W6ru//wejf9ZnlmIR6P\n"
"lWxPwvhtPFVXmgggucEdFJarRmp4ZgZTIJ8phbEVeqa7K90Aq7aR5wS2fYatcm7o\n"
"LxBONcoekydKPsd5VTf9DSELoWwY5OXZfrHnefEfNblPpnd50x4BnQ==\n"
"-----END RSA PRIVATE KEY-----";

const char *governance_string = "data:,MIME-Version: 1.0\n"
"Content-Type: multipart/signed; protocol=\"application/pkcs7-signature\"; micalg=\"sha-256\"; boundary=\"----BB9F390D5E2367A71734CDA2235A5EF9\"\n"
"\n"
"This is an S/MIME signed message\n"
"\n"
"------BB9F390D5E2367A71734CDA2235A5EF9\n"
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
"<dds xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" \n"
"     xsi:noNamespaceSchemaLocation=\"http://www.omg.org/spec/DDS-SECURITY/20170901/omg_shared_ca_governance.xsd\">\n"
"    <!--\n"
"    A governance file is composed of 1 or more domain_rule elements, inside a\n"
"    parent domain_access_rules element.\n"
"    -->\n"
"    <domain_access_rules>\n"
"        <!--\n"
"        A domain_rule defines which security protections should be enforced on\n"
"        a set of DDS domains and their contained topics.\n"
"        -->\n"
"        <domain_rule>\n"
"            <!--\n"
"            The domains element specifies the range of domains affected by\n"
"            the parent domain_rule.\n"
"            -->\n"
"            <domains>\n"
"                <!-- \n"
"                Domains can be specified individually with the id element \n"
"                -->\n"
"                <id>0</id>\n"
"                <!--\n"
"                A range of domains can be specified with the id_range element.\n"
"                -->\n"
"                <id_range>\n"
"                    <min>1</min>\n"
"                    <max>10</max>\n"
"                </id_range>\n"
"            </domains>\n"
"            <!-- \n"
"            allow_unauthenticated_participants can be set to \"true\" to enable\n"
"            communication on \"unsecure topics\" (i.e. topics with all \n"
"            protections disabled and all protection kinds set to NONE) even\n"
"            when a participant fails to authenticate (or it doesn't support\n"
"            DDS Security at all).\n"
"            \n"
"            If set to \"false\", any participant who fails to complete the\n"
"            authentication handshake will be ignored.\n"
"            \n"
"            When this property is enabled, rtps_protection_kind must be set to\n"
"            NONE, or it would be impossible for unauthenticated participants to\n"
"            properly decode received RTPS messages.\n"
"            -->\n"
"            <allow_unauthenticated_participants>false</allow_unauthenticated_participants>\n"
"            <!--\n"
"            enable_join_access_control can be set to \"false\" to disable access\n"
"            control checks during creation of local participants, and discovery \n"
"            of remote ones. When access control is disabled, the secure \n"
"            discovery endpoints will also be discoverable by remote participants\n"
"            regardless of their permissions.\n"
"            \n"
"            EAR WARNING: only \"true\" is currently supported.\n"
"            -->\n"
"            <enable_join_access_control>true</enable_join_access_control>\n"
"            <!--\n"
"            discovery_protection_kind controls the type of protection to be \n"
"            applied on data exchanged by the secure discovery endpoints.\n"
"            -->\n"
"            <discovery_protection_kind>ENCRYPT</discovery_protection_kind>\n"
"            <!--\n"
"            liveliness_protection_kind controls the type of protection to be \n"
"            applied on messages exchanged on the ParticipantMessage \n"
"            inter-participant channel to maintain liveliness between \n"
"            participants and endpoints.\n"
"            \n"
"            Since RTI Connext DDS Micro does not support this inter-participant\n"
"            channel, this setting is currently ignored, but the XML element\n"
"            must be included to maintain conformance with the XSD definition.\n"
"            -->\n"
"            <liveliness_protection_kind>SIGN</liveliness_protection_kind>\n"
"            <!--\n"
"            rtps_protection_kind controls the type of protection to be applied\n"
"            on RTPS messages produced by the participant.\n"
"            -->\n"
"            <rtps_protection_kind>ENCRYPT_WITH_ORIGIN_AUTHENTICATION</rtps_protection_kind>\n"
"            <!--\n"
"            The topic_access_rules section must contain 1 or more topic_rule\n"
"            elements to define security properties of each topic in the domain.\n"
"            -->\n"
"            <topic_access_rules>\n"
"                <!--\n"
"                A topic_rule defines a set of security properties for one\n"
"                or more topics identified by the topic_expression.\n"
"                -->\n"
"                <topic_rule>\n"
"                    <!--\n"
"                    A topic_expression can use the '*' character to perform\n"
"                    simple matching on the suffix part of the topic name \n"
"                    -->\n"
"                    <topic_expression>Example *</topic_expression>\n"
"                    <!--\n"
"                    If enable_discovery_protection is \"true\", the topic will \n"
"                    be announced on the secure discovery endpoints, and \n"
"                    matchable only by authenticated participants.\n"
"                    -->\n"
"                    <enable_discovery_protection>true</enable_discovery_protection>\n"
"                    <!--\n"
"                    RTI Connext DDS Micro does not support endpoint-level\n"
"                    liveliness assertion, which can be made secure using this\n"
"                    property.\n"
"                    \n"
"                    This setting is currently ignored, but the XML element must\n"
"                    be included to maintain conformance with the XSD.\n"
"                    -->\n"
"                    <enable_liveliness_protection>true</enable_liveliness_protection>\n"
"                    <!--\n"
"                    If enable_read_access_control is set to \"false\", the \n"
"                    middleware will not perform access control checks when\n"
"                    creating and/or discovering DataReaders on this topic\n"
"                    -->\n"
"                    <enable_read_access_control>true</enable_read_access_control>\n"
"                    <!--\n"
"                    If enable_write_access_control is set to \"false\", the \n"
"                    middleware will not perform access control checks when\n"
"                    creating and/or discovering DataWriters on this topic\n"
"                    -->\n"
"                    <enable_write_access_control>true</enable_write_access_control>\n"
"                    <!--\n"
"                    metadata_protection_kind controls the type of protection to\n"
"                    be applied on RTPS Submessages exchanged by endpoints for\n"
"                    this topic.\n"
"                    -->\n"
"                    <metadata_protection_kind>ENCRYPT</metadata_protection_kind>\n"
"                    <!--\n"
"                    metadata_protection_kind controls the type of protection to\n"
"                    be applied on data samples exchanged by endpoints for\n"
"                    this topic.\n"
"                    \n"
"                    EAR WARNING: only NONE is currently supported.\n"
"                    -->\n"
"                    <data_protection_kind>ENCRYPT</data_protection_kind>\n"
"                </topic_rule>\n"
"            </topic_access_rules>\n"
"        </domain_rule>\n"
"    </domain_access_rules>\n"
"</dds>\n"
"\n"
"------BB9F390D5E2367A71734CDA2235A5EF9\n"
"Content-Type: application/pkcs7-signature; name=\"smime.p7s\"\n"
"Content-Transfer-Encoding: base64\n"
"Content-Disposition: attachment; filename=\"smime.p7s\"\n"
"\n"
"MIIGcwYJKoZIhvcNAQcCoIIGZDCCBmACAQExDTALBglghkgBZQMEAgEwCwYJKoZI\n"
"hvcNAQcBoIIDkjCCA44wggJ2AgkA+U34hoRC6h8wDQYJKoZIhvcNAQELBQAwgYgx\n"
"CzAJBgNVBAYTAlVTMQswCQYDVQQIDAJDQTESMBAGA1UEBwwJU3Vubnl2YWxlMRgw\n"
"FgYDVQQKDA9NeSBPcmdhbml6YXRpb24xEjAQBgNVBAMMCU15IE9yZyBDQTEqMCgG\n"
"CSqGSIb3DQEJARYbZXhhbXBsZUBteS1vcmdhbml6YXRpb24uY29tMB4XDTE5MDkx\n"
"MDIwMzkzNloXDTI5MDkwNzIwMzkzNlowgYgxCzAJBgNVBAYTAlVTMQswCQYDVQQI\n"
"DAJDQTESMBAGA1UEBwwJU3Vubnl2YWxlMRgwFgYDVQQKDA9NeSBPcmdhbml6YXRp\n"
"b24xEjAQBgNVBAMMCU15IE9yZyBDQTEqMCgGCSqGSIb3DQEJARYbZXhhbXBsZUBt\n"
"eS1vcmdhbml6YXRpb24uY29tMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKC\n"
"AQEA3cpjKEWWGDx6meR3QXbt4SknbxFkwikj9wxvJIIR/CHtdVNQrOB7PlFphIv6\n"
"8+7gfewM+YXPPLrychcr882V9xUfhu50Hwe5qX7hNRTOREVSs5Ahbi1/HVWc9Ifv\n"
"PDa1rEFUgg/RdFrGjQRP7+6EF8Ii33U26aIt21hFesvLGeQSCfwWat8fx02XBY79\n"
"1r9HwBSDMTbKaJdXl1uKp5pzT0ARrzEsi3Hd3zcC1V5Ls2WMQPwg8pkn5xaTC1bR\n"
"SnktKd16zOZp4ZXyyS94HyuHcZjRtwAiJqKQFwHxUSWQ53DQZA1GPkmae08j7EQe\n"
"dGbL5DgGXWyfANujFOWIX81ObQIDAQABMA0GCSqGSIb3DQEBCwUAA4IBAQB0QdEW\n"
"x0kNy7TsZYYv//409freOlA2sF+Iw9k/IO/anXwEue34nVgjd7ZiG4q7wIgvANIJ\n"
"e6QzdR0+K2g0SveErC/bBRabwbaGFpsRrJsgJUOpOY8056s5RcIHzzq9r71Rutzk\n"
"F12rD7cyjW/el6qrVPBzxSNjXiwyNVzbrSTh+RIybDrpFebf9I4ekEAeIXhWGT68\n"
"JVqgn8TBgkFPfw3PaEGn06ysSxW6i1FEviLSVjQxI3LvInbRZ+NTkJWArm2GGTfY\n"
"p2hoc+NrL+dLCtNzoK7i7k2easf6r8nz8436yu11oMWWGgZFNZlYM3h9UwZFV75o\n"
"UQRXO6dUXAKNSRUxMYICpzCCAqMCAQEwgZYwgYgxCzAJBgNVBAYTAlVTMQswCQYD\n"
"VQQIDAJDQTESMBAGA1UEBwwJU3Vubnl2YWxlMRgwFgYDVQQKDA9NeSBPcmdhbml6\n"
"YXRpb24xEjAQBgNVBAMMCU15IE9yZyBDQTEqMCgGCSqGSIb3DQEJARYbZXhhbXBs\n"
"ZUBteS1vcmdhbml6YXRpb24uY29tAgkA+U34hoRC6h8wCwYJYIZIAWUDBAIBoIHk\n"
"MBgGCSqGSIb3DQEJAzELBgkqhkiG9w0BBwEwHAYJKoZIhvcNAQkFMQ8XDTE5MDkx\n"
"MDIzMjgwOVowLwYJKoZIhvcNAQkEMSIEIMwn+6HDVFh4uX72ulS/01ahNPreHgkj\n"
"t9J6W3X3zDDmMHkGCSqGSIb3DQEJDzFsMGowCwYJYIZIAWUDBAEqMAsGCWCGSAFl\n"
"AwQBFjALBglghkgBZQMEAQIwCgYIKoZIhvcNAwcwDgYIKoZIhvcNAwICAgCAMA0G\n"
"CCqGSIb3DQMCAgFAMAcGBSsOAwIHMA0GCCqGSIb3DQMCAgEoMA0GCSqGSIb3DQEB\n"
"AQUABIIBAKlePdQMGfg7NH4so4uiaus4nuYMWS3cpJD+ZgZetHYtOLGcSNqWY3uc\n"
"Ea82VciG8ZZaCqTv/m6O3Ui2cmrDVhgBU9DCpCAz4E2PTUjYMNXc5enRgH8d8nFN\n"
"wsE6QophSmQGSFIiKJLR6WU5moc4FACcN0ZlUTGnyu708oM/bliewNBKhRnzgk0A\n"
"sbLP6CWZlJxmr36btToFAx7v2Y1tUUsw8/+Z+33MFUYWwMR6bfENE+Ekc+HYO079\n"
"WwaPH/j4cAD4TuHRE6lNZ+PeKrtBO6gxXg3UFBojExrinrro8FnPxN2jPNiHpATv\n"
"5V68ivZvj5EPQSmvZZQXqf7kReScdF8=\n"
"\n"
"------BB9F390D5E2367A71734CDA2235A5EF9--\n";

const char *permissions_subscriber_string = "data:,MIME-Version: 1.0\n"
"Content-Type: multipart/signed; protocol=\"application/pkcs7-signature\"; micalg=\"sha-256\"; boundary=\"----1DB3DE3A50BE24320AB091B9F3C258F4\"\n"
"\n"
"This is an S/MIME signed message\n"
"\n"
"------1DB3DE3A50BE24320AB091B9F3C258F4\n"
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
"<dds xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
"     xsi:noNamespaceSchemaLocation=\"http://www.omg.org/spec/DDS-Security/20170901/omg_shared_ca_permissions.xsd\">\n"
"    <!--\n"
"    A permissions files contains 1 or more grant elements for local\n"
"    DomainParticipants. Rules for discovered DomainParticipants will be \n"
"    exchanged at run-time.\n"
"    \n"
"    Since RTI Connext DDS Micro performs validation using the official OMG \n"
"    XSD definition, all elements must be included and defined in the presented\n"
"    order. The XML elements must also follow proper XSD types syntax. Note that\n"
"    this means that for boolean elements the only legal values are \"true\" and \n"
"    \"false\".\n"
"    -->\n"
"    <permissions>\n"
"        <!--\n"
"        Each grant defines the domains and topics which a DomainParticipant, \n"
"        identified by the grant's subject_name, may or may not access.\n"
"        The grant's name must be unique within the document.\n"
"        -->\n"
"        <grant name=\"HelloWorldPermissions\">\n"
"            <!--\n"
"            subject_name must match the identity used to generate the \n"
"            DomainParticipant's certificate.\n"
"            -->\n"
"            <subject_name>/C=US/ST=CA/O=My Organization/CN=A subscriber/emailAddress=subscriber@my-organization.com</subject_name>\n"
"            <!--\n"
"            The validity imposes lower and upper time limits on the \n"
"            applicability of the enclosing grant.\n"
"            -->\n"
"            <validity>\n"
"                <!-- \n"
"                Format is CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm] \n"
"                The time zone may be specified as Z (UTC) or (+|-)hh:mm.\n"
"                If the time zone isn't specified, it assumed to be UTC. \n"
"                -->\n"
"                <not_before>2018-06-01T00:00:00</not_before>\n"
"                <not_after>2023-05-31T23:59:59</not_after>\n"
"            </validity>\n"
"            <!--\n"
"            A grant can contain 1 or more allow_rule and/or deny_rule elements.\n"
"            Each rule pertains a range of domains. An allow_rule provides\n"
"            access for publishing and or subscribing to the topics selected\n"
"            by the enclosed publish and subscribe elements. A deny_rule \n"
"            explicitly forbids the DomainParticipant to access the selected\n"
"            domains and topic.\n"
"            -->\n"
"            <allow_rule>\n"
"                <!--\n"
"                The domains elements specifies the range of domains affected\n"
"                by the enclosing rule. It is similar to the one used by \n"
"                the governance file's domain_rule element.\n"
"                -->\n"
"                <domains>\n"
"                    <id>0</id>\n"
"                    <id_range>\n"
"                        <min>1</min>\n"
"                        <max>10</max>\n"
"                    </id_range>\n"
"                </domains>\n"
"                <!--\n"
"                The publish element enables/disables access to DataWriters\n"
"                for the select topic(s).\n"
"                -->\n"
"                <publish>\n"
"                    <!--\n"
"                    1 or more topic elements must be specified. These elements\n"
"                    must match the full name of the desired topics.\n"
"                    -->\n"
"                    <topics>\n"
"                        <topic>Example HelloWorld</topic>\n"
"                    </topics>\n"
"                    <!--\n"
"                    The scope of the enclosing element can be further refined\n"
"                    by specifying tag elements. Only DataWriters with the\n"
"                    selected tags in their DataTagQosPolicy will be subjected\n"
"                    to the rule.\n"
"                    \n"
"                    EAR WARNING: data tags are not currently supported. Their\n"
"                    inclusion in this file is meant only as an example.\n"
"                    -->\n"
"                    <data_tags>\n"
"                        <tag>\n"
"                            <name>aTagName1</name>\n"
"                            <value>aTagValue1</value>\n"
"                        </tag>\n"
"                    </data_tags>\n"
"                </publish>\n"
"                <!--\n"
"                The subscribe element enables/disables access to DataReaders\n"
"                for the select topic(s).\n"
"                \n"
"                It's contents are similar to those of the publish element.\n"
"                -->\n"
"                <subscribe>\n"
"                    <topics>\n"
"                        <topic>Example HelloWorld</topic>\n"
"                    </topics>\n"
"                    <data_tags>\n"
"                        <tag>\n"
"                            <name>aTagName1</name>\n"
"                            <value>aTagValue1</value>\n"
"                        </tag>\n"
"                        <tag>\n"
"                            <name>aTagName2</name>\n"
"                            <value>aTagValue2</value>\n"
"                        </tag>\n"
"                    </data_tags>\n"
"                </subscribe>\n"
"            </allow_rule>\n"
"            <!--\n"
"            A default element can be included to define default rules for all\n"
"            domains and topics not explicitly covered by any of the rules in \n"
"            the grant. Accepted values are DENY and ALLOW.\n"
"            -->\n"
"            <default>DENY</default>\n"
"        </grant>\n"
"    </permissions>\n"
"</dds>\n"
"------1DB3DE3A50BE24320AB091B9F3C258F4\n"
"Content-Type: application/pkcs7-signature; name=\"smime.p7s\"\n"
"Content-Transfer-Encoding: base64\n"
"Content-Disposition: attachment; filename=\"smime.p7s\"\n"
"\n"
"MIIGcwYJKoZIhvcNAQcCoIIGZDCCBmACAQExDTALBglghkgBZQMEAgEwCwYJKoZI\n"
"hvcNAQcBoIIDkjCCA44wggJ2AgkA+U34hoRC6h8wDQYJKoZIhvcNAQELBQAwgYgx\n"
"CzAJBgNVBAYTAlVTMQswCQYDVQQIDAJDQTESMBAGA1UEBwwJU3Vubnl2YWxlMRgw\n"
"FgYDVQQKDA9NeSBPcmdhbml6YXRpb24xEjAQBgNVBAMMCU15IE9yZyBDQTEqMCgG\n"
"CSqGSIb3DQEJARYbZXhhbXBsZUBteS1vcmdhbml6YXRpb24uY29tMB4XDTE5MDkx\n"
"MDIwMzkzNloXDTI5MDkwNzIwMzkzNlowgYgxCzAJBgNVBAYTAlVTMQswCQYDVQQI\n"
"DAJDQTESMBAGA1UEBwwJU3Vubnl2YWxlMRgwFgYDVQQKDA9NeSBPcmdhbml6YXRp\n"
"b24xEjAQBgNVBAMMCU15IE9yZyBDQTEqMCgGCSqGSIb3DQEJARYbZXhhbXBsZUBt\n"
"eS1vcmdhbml6YXRpb24uY29tMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKC\n"
"AQEA3cpjKEWWGDx6meR3QXbt4SknbxFkwikj9wxvJIIR/CHtdVNQrOB7PlFphIv6\n"
"8+7gfewM+YXPPLrychcr882V9xUfhu50Hwe5qX7hNRTOREVSs5Ahbi1/HVWc9Ifv\n"
"PDa1rEFUgg/RdFrGjQRP7+6EF8Ii33U26aIt21hFesvLGeQSCfwWat8fx02XBY79\n"
"1r9HwBSDMTbKaJdXl1uKp5pzT0ARrzEsi3Hd3zcC1V5Ls2WMQPwg8pkn5xaTC1bR\n"
"SnktKd16zOZp4ZXyyS94HyuHcZjRtwAiJqKQFwHxUSWQ53DQZA1GPkmae08j7EQe\n"
"dGbL5DgGXWyfANujFOWIX81ObQIDAQABMA0GCSqGSIb3DQEBCwUAA4IBAQB0QdEW\n"
"x0kNy7TsZYYv//409freOlA2sF+Iw9k/IO/anXwEue34nVgjd7ZiG4q7wIgvANIJ\n"
"e6QzdR0+K2g0SveErC/bBRabwbaGFpsRrJsgJUOpOY8056s5RcIHzzq9r71Rutzk\n"
"F12rD7cyjW/el6qrVPBzxSNjXiwyNVzbrSTh+RIybDrpFebf9I4ekEAeIXhWGT68\n"
"JVqgn8TBgkFPfw3PaEGn06ysSxW6i1FEviLSVjQxI3LvInbRZ+NTkJWArm2GGTfY\n"
"p2hoc+NrL+dLCtNzoK7i7k2easf6r8nz8436yu11oMWWGgZFNZlYM3h9UwZFV75o\n"
"UQRXO6dUXAKNSRUxMYICpzCCAqMCAQEwgZYwgYgxCzAJBgNVBAYTAlVTMQswCQYD\n"
"VQQIDAJDQTESMBAGA1UEBwwJU3Vubnl2YWxlMRgwFgYDVQQKDA9NeSBPcmdhbml6\n"
"YXRpb24xEjAQBgNVBAMMCU15IE9yZyBDQTEqMCgGCSqGSIb3DQEJARYbZXhhbXBs\n"
"ZUBteS1vcmdhbml6YXRpb24uY29tAgkA+U34hoRC6h8wCwYJYIZIAWUDBAIBoIHk\n"
"MBgGCSqGSIb3DQEJAzELBgkqhkiG9w0BBwEwHAYJKoZIhvcNAQkFMQ8XDTE5MDkx\n"
"MDIwMzkzNlowLwYJKoZIhvcNAQkEMSIEIBGy3txuRXaQtHgyiarwK9XbF8Xiyenk\n"
"UZIHXl1vd+jBMHkGCSqGSIb3DQEJDzFsMGowCwYJYIZIAWUDBAEqMAsGCWCGSAFl\n"
"AwQBFjALBglghkgBZQMEAQIwCgYIKoZIhvcNAwcwDgYIKoZIhvcNAwICAgCAMA0G\n"
"CCqGSIb3DQMCAgFAMAcGBSsOAwIHMA0GCCqGSIb3DQMCAgEoMA0GCSqGSIb3DQEB\n"
"AQUABIIBAMekRu6O2VZDh2FPXsytaJ3yConiiS7xIsqXaSjbZGupi0nIGabTDtUv\n"
"b+odrETFuJQbLJjHJzgoBSB3aUtZtlRa0zbmXpMvCLahX3LG87okYhbQbhisQNoC\n"
"jOIsolhmJOmJti99hPEDRpj0TBmzIZAxGWA6FZdKiniR9opllRdP+RyvKCxH1X/Q\n"
"AHYWuGxuWzR/lVZ4SWIWCUrFMqyw8aEE8mOuQPbADuzK3xjT8TKcOt5LcnN81BLQ\n"
"aoyDwp0vbM87YeOR6Q3lVAYuBK3lFaMBO+fwHhg9Q/qKB/WUkTHGy+n8qK7sNxqT\n"
"s0RNvFSf38u2nSLFPZORy/y3jU4v+t8=\n"
"\n"
"------1DB3DE3A50BE24320AB091B9F3C258F4--\n";

const char *publisher_string = "data:,Certificate:\n"
"    Data:\n"
"        Version: 1 (0x0)\n"
"        Serial Number: 1 (0x1)\n"
"    Signature Algorithm: sha256WithRSAEncryption\n"
"        Issuer: C=US, ST=CA, L=Sunnyvale, O=My Organization, CN=My Org CA/emailAddress=example@my-organization.com\n"
"        Validity\n"
"            Not Before: Sep 10 20:39:36 2019 GMT\n"
"            Not After : Sep  9 20:39:36 2020 GMT\n"
"        Subject: C=US, ST=CA, O=My Organization, CN=A publisher/emailAddress=publisher@my-organization.com\n"
"        Subject Public Key Info:\n"
"            Public Key Algorithm: rsaEncryption\n"
"                Public-Key: (2048 bit)\n"
"                Modulus:\n"
"                    00:af:32:75:78:32:6e:09:d6:4c:57:12:ae:95:4f:\n"
"                    86:d8:0f:21:b1:14:95:5e:42:2f:76:88:a2:69:b5:\n"
"                    72:cc:f9:8a:9a:1f:70:ec:19:12:f1:8d:d9:6e:2f:\n"
"                    e6:87:55:6c:d5:ed:b9:58:22:20:90:c6:77:f4:b3:\n"
"                    27:5f:05:a7:96:4f:9a:3e:30:c3:5e:24:4d:61:db:\n"
"                    b0:46:82:e6:29:0a:67:4d:6a:58:a2:7a:96:5e:0c:\n"
"                    ed:36:60:6b:ba:2c:c2:e2:e4:33:1b:de:d2:36:27:\n"
"                    40:92:ab:02:d4:3a:6a:12:aa:0a:be:b1:e6:9c:81:\n"
"                    39:fe:19:a3:ab:ff:fc:c2:87:30:ad:20:0c:12:37:\n"
"                    2a:e1:7c:69:e3:7f:75:07:3f:ed:1a:63:91:48:41:\n"
"                    78:f9:25:66:db:f3:ca:95:87:71:ce:36:8f:60:c8:\n"
"                    ca:06:98:be:57:38:ec:5b:69:f8:ca:e0:be:2c:5d:\n"
"                    01:23:91:23:e8:d8:1c:7c:36:25:9d:d3:ad:36:f4:\n"
"                    17:b0:35:27:69:0a:8c:6f:6c:2b:2f:e6:d3:cb:f2:\n"
"                    2e:53:dd:8a:bb:e1:a3:09:fb:79:2f:e2:07:2d:b8:\n"
"                    73:f6:89:bb:cc:29:ed:9d:ae:10:82:f9:5d:e4:07:\n"
"                    28:40:ff:1f:fe:5c:ed:66:08:81:91:6c:63:d7:f6:\n"
"                    95:e7\n"
"                Exponent: 65537 (0x10001)\n"
"    Signature Algorithm: sha256WithRSAEncryption\n"
"         ba:23:f0:11:f0:f0:17:4f:12:8c:fe:e2:ff:1e:fd:a9:f8:ef:\n"
"         8a:3b:91:b9:db:de:41:e3:2b:b8:83:44:29:92:f3:81:11:70:\n"
"         55:38:ec:f6:cf:a9:09:68:d4:b2:50:8d:a7:d4:9e:db:77:20:\n"
"         66:83:ff:c3:42:c6:4b:71:63:81:1a:55:6c:3b:e9:c4:88:99:\n"
"         80:9b:cd:e8:82:99:0d:06:2f:8b:fd:55:e5:3d:71:11:6e:39:\n"
"         3d:a6:be:9b:09:02:d9:b4:c2:61:89:7a:cb:3d:31:be:58:93:\n"
"         ac:51:d8:8f:2d:be:5d:9a:f8:a4:50:96:63:92:93:90:d5:97:\n"
"         56:76:00:51:cf:f0:a8:7a:4f:43:5a:a7:74:64:66:48:8e:8d:\n"
"         be:0d:5f:68:da:ea:3a:08:37:ce:d5:f5:2b:4a:8e:39:88:74:\n"
"         9d:0b:eb:6e:a6:73:a7:32:36:8f:c8:20:05:42:ca:d0:ee:63:\n"
"         5e:66:22:52:ef:58:4b:23:d0:74:81:ea:fd:9a:06:86:17:2f:\n"
"         d8:15:28:f0:de:ef:8f:ab:82:8a:21:0e:7b:bf:02:84:d1:9c:\n"
"         f7:3c:7c:8d:06:70:f1:e5:5f:ca:a7:d1:c4:34:6b:72:e9:53:\n"
"         e2:8e:62:61:ad:88:7b:35:a8:9e:5f:4a:90:ce:ae:04:16:14:\n"
"         6b:a4:ea:e4\n"
"-----BEGIN CERTIFICATE-----\n"
"MIIDdTCCAl0CAQEwDQYJKoZIhvcNAQELBQAwgYgxCzAJBgNVBAYTAlVTMQswCQYD\n"
"VQQIDAJDQTESMBAGA1UEBwwJU3Vubnl2YWxlMRgwFgYDVQQKDA9NeSBPcmdhbml6\n"
"YXRpb24xEjAQBgNVBAMMCU15IE9yZyBDQTEqMCgGCSqGSIb3DQEJARYbZXhhbXBs\n"
"ZUBteS1vcmdhbml6YXRpb24uY29tMB4XDTE5MDkxMDIwMzkzNloXDTIwMDkwOTIw\n"
"MzkzNloweDELMAkGA1UEBhMCVVMxCzAJBgNVBAgMAkNBMRgwFgYDVQQKDA9NeSBP\n"
"cmdhbml6YXRpb24xFDASBgNVBAMMC0EgcHVibGlzaGVyMSwwKgYJKoZIhvcNAQkB\n"
"Fh1wdWJsaXNoZXJAbXktb3JnYW5pemF0aW9uLmNvbTCCASIwDQYJKoZIhvcNAQEB\n"
"BQADggEPADCCAQoCggEBAK8ydXgybgnWTFcSrpVPhtgPIbEUlV5CL3aIomm1csz5\n"
"ipofcOwZEvGN2W4v5odVbNXtuVgiIJDGd/SzJ18Fp5ZPmj4ww14kTWHbsEaC5ikK\n"
"Z01qWKJ6ll4M7TZga7oswuLkMxve0jYnQJKrAtQ6ahKqCr6x5pyBOf4Zo6v//MKH\n"
"MK0gDBI3KuF8aeN/dQc/7RpjkUhBePklZtvzypWHcc42j2DIygaYvlc47Ftp+Mrg\n"
"vixdASORI+jYHHw2JZ3TrTb0F7A1J2kKjG9sKy/m08vyLlPdirvhown7eS/iBy24\n"
"c/aJu8wp7Z2uEIL5XeQHKED/H/5c7WYIgZFsY9f2lecCAwEAATANBgkqhkiG9w0B\n"
"AQsFAAOCAQEAuiPwEfDwF08SjP7i/x79qfjvijuRudveQeMruINEKZLzgRFwVTjs\n"
"9s+pCWjUslCNp9Se23cgZoP/w0LGS3FjgRpVbDvpxIiZgJvN6IKZDQYvi/1V5T1x\n"
"EW45Paa+mwkC2bTCYYl6yz0xvliTrFHYjy2+XZr4pFCWY5KTkNWXVnYAUc/wqHpP\n"
"Q1qndGRmSI6Nvg1faNrqOgg3ztX1K0qOOYh0nQvrbqZzpzI2j8ggBULK0O5jXmYi\n"
"Uu9YSyPQdIHq/ZoGhhcv2BUo8N7vj6uCiiEOe78ChNGc9zx8jQZw8eVfyqfRxDRr\n"
"culT4o5iYa2IezWonl9KkM6uBBYUa6Tq5A==\n"
"-----END CERTIFICATE-----";

const char *publisher_key_string = "data:,-----BEGIN RSA PRIVATE KEY-----\n"
"MIIEpAIBAAKCAQEArzJ1eDJuCdZMVxKulU+G2A8hsRSVXkIvdoiiabVyzPmKmh9w\n"
"7BkS8Y3Zbi/mh1Vs1e25WCIgkMZ39LMnXwWnlk+aPjDDXiRNYduwRoLmKQpnTWpY\n"
"onqWXgztNmBruizC4uQzG97SNidAkqsC1DpqEqoKvrHmnIE5/hmjq//8wocwrSAM\n"
"Ejcq4Xxp4391Bz/tGmORSEF4+SVm2/PKlYdxzjaPYMjKBpi+VzjsW2n4yuC+LF0B\n"
"I5Ej6NgcfDYlndOtNvQXsDUnaQqMb2wrL+bTy/IuU92Ku+GjCft5L+IHLbhz9om7\n"
"zCntna4Qgvld5AcoQP8f/lztZgiBkWxj1/aV5wIDAQABAoIBAAMPlZ/Q+b0wQksv\n"
"J1+ycP+rXAJVArsP2vZuMrA4HFZaccJ5lCZ71ankuYzER3nL00f1jExu5DTDUusy\n"
"ihiN57ynjWFSxscJSVTRWsYQmWbUKLPgjMXh8GiaPza4/ojVKV5/cCknfnK1wtoN\n"
"JNKCZsIGuINWZloLo/C9j+98XHUlkhX8W8tqvepzhld+B+4aEl5AidxpB/X52Mtn\n"
"2pCFdyIuXUU8fHDX4IhXGjCLDegbbeJ3ZQBM/NyUxDgpcIlKbnQFPbmD1Gs+2JXR\n"
"E6fdImNCQHn1lb2XPD53yzZc1d21ufjPm9i2yZKSMwrcMhw0V2TXTqQerOBb/LzZ\n"
"J7VkzkkCgYEA5mPa3PrXq6+Lwqtzy4SXauJPhKHhwilx1+t926640vyf8/fIB/at\n"
"a/A/kp5AJItAald/JZXKsDS1iGiBm1aklk5ROLPSLjqXFn1DrFQUfqRDnTSsCIF7\n"
"zHd1D3ttACaZfP8HVLeNu5DYxFslG3bKLBBsO06VzWZmndXnMuWMCCsCgYEAwqv+\n"
"W6JSAfJYN6X2xlKWhGHopkLnkXjFfwIzwox5Sike4/CMHv+G2Z66LqrGdWoIEh9B\n"
"sZa4jbxEYjwGqWqEVL1Uc3+BK+re0T4HE42dguazUj+ZUTmCRRZt4/f3xWWQKvDl\n"
"TUvqm7lD1TKB/Qb1+enD+SkciKBq3fTH6tfrLzUCgYASWqAj/KPT3J9QueH2s7Bw\n"
"ZmkZUuAuXKjiH7OeHbRBsrh3ciTwZXl5YOFfp9XKU4GlNyU89Er6cKiJnnG801E3\n"
"XDPiRYkX/7jrpL0QbH5ZfHKagoi2AMLBDj84JYgQfAK8T4DhAeJ7r9VlBzHUl0kR\n"
"65kDvIX4oBDKwDC0AE+AkwKBgQCrEadw8QBt04AwTri/6N16MevXBx4lmOK8zLud\n"
"cAI56E7L8ZvAtb3TyQdFcS77CRVUj4EURSWi79mMFcGo6QCm0sW+xUJGzJvHdmGT\n"
"jjPnT0IvudHKLeZLPf2Ngl+KaMi643wtY9QjyjdQx5SxPIe1ePaNItJ/QbEHoU55\n"
"EgsLLQKBgQDFvFZqVgqDC4upcsf069qHFv9KWuPc7iwK0vpQFMBiO56lz8AXyIAH\n"
"8k5+RPH2GlS5Ea7bMvtkp6hMstrVMA7O6AK2KTuZcO0004fiVifF9ZxQYJrRnjPd\n"
"Vkkv4EzNWLq+VkcBqitJ4m/mI1S7olZDvhCQoOeEOencZPQnypOwHg==\n"
"-----END RSA PRIVATE KEY-----";

const char *permissions_publisher_string = "data:,MIME-Version: 1.0\n"
"Content-Type: multipart/signed; protocol=\"application/pkcs7-signature\"; micalg=\"sha-256\"; boundary=\"----146BEB6E03BFC9E6ADC53703DC207707\"\n"
"\n"
"This is an S/MIME signed message\n"
"\n"
"------146BEB6E03BFC9E6ADC53703DC207707\n"
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
"<dds xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" \n"
"     xsi:noNamespaceSchemaLocation=\"http://www.omg.org/spec/DDS-Security/20170901/omg_shared_ca_permissions.xsd\">\n"
"    <!--\n"
"    A permissions files contains 1 or more grant elements for local\n"
"    DomainParticipants. Rules for discovered DomainParticipants will be \n"
"    exchanged at run-time.\n"
"    \n"
"    Since RTI Connext DDS Micro performs validation using the official OMG \n"
"    XSD definition, all elements must be included and defined in the presented\n"
"    order. The XML elements must also follow proper XSD types syntax. Note that\n"
"    this means that for boolean elements the only legal values are \"true\" and \n"
"    \"false\".\n"
"    -->\n"
"    <permissions>\n"
"        <!--\n"
"        Each grant defines the domains and topics which a DomainParticipant, \n"
"        identified by the grant's subject_name, may or may not access.\n"
"        The grant's name must be unique within the document.\n"
"        -->\n"
"        <grant name=\"HelloWorldPermissions\">\n"
"            <!--\n"
"            subject_name must match the identity used to generate the \n"
"            DomainParticipant's certificate.\n"
"            -->\n"
"            <subject_name>/C=US/ST=CA/O=My Organization/CN=A publisher/emailAddress=publisher@my-organization.com</subject_name>\n"
"            <!--\n"
"            The validity imposes lower and upper time limits on the \n"
"            applicability of the enclosing grant.\n"
"            -->\n"
"            <validity>\n"
"                <!-- \n"
"                Format is CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm] \n"
"                The time zone may be specified as Z (UTC) or (+|-)hh:mm.\n"
"                If the time zone isn't specified, it assumed to be UTC. \n"
"                -->\n"
"                <not_before>2018-06-01T00:00:00</not_before>\n"
"                <not_after>2023-05-31T23:59:59</not_after>\n"
"            </validity>\n"
"            <!--\n"
"            A grant can contain 1 or more allow_rule and/or deny_rule.\n"
"            Each rule pertains a range of domains. An allow_rule provides\n"
"            access for publishing and or subscribing to the topics selected\n"
"            by the enclosed publish and subscribe elements. A deny_rule \n"
"            explicitly forbids the DomainParticipant to access the selected\n"
"            domains and topic.\n"
"            -->\n"
"            <allow_rule>\n"
"                <!--\n"
"                The domains elements specifies the range of domains affected\n"
"                by the enclosing rule. It is similar to the one used by \n"
"                the governance file's domain_rule element.\n"
"                -->\n"
"                <domains>\n"
"                    <id>0</id>\n"
"                    <id_range>\n"
"                        <min>1</min>\n"
"                        <max>10</max>\n"
"                    </id_range>\n"
"                </domains>\n"
"                <!--\n"
"                The publish element enables/disables access to DataWriters\n"
"                for the select topic(s).\n"
"                -->\n"
"                <publish>\n"
"                    <!--\n"
"                    1 or more topic elements must be specified. These elements\n"
"                    must match the full name of the desired topics.\n"
"                    -->\n"
"                    <topics>\n"
"                        <topic>Example HelloWorld</topic>\n"
"                    </topics>\n"
"                    <!--\n"
"                    The scope of the enclosing element can be further refined\n"
"                    by specifying tag elements. Only DataWriters with the\n"
"                    selected tags in their DataTagQosPolicy will be subjected\n"
"                    to the rule.\n"
"                    \n"
"                    EAR WARNING: data tags are not currently supported. Their\n"
"                    inclusion in this file is meant only as an example.\n"
"                    -->\n"
"                    <data_tags>\n"
"                        <tag>\n"
"                            <name>aTagName1</name>\n"
"                            <value>aTagValue1</value>\n"
"                        </tag>\n"
"                    </data_tags>\n"
"                </publish>\n"
"                <!--\n"
"                The subscribe element enables/disables access to DataReaders\n"
"                for the select topic(s).\n"
"                \n"
"                It's contents are similar to those of the publish element.\n"
"                -->\n"
"                <subscribe>\n"
"                    <topics>\n"
"                        <topic>Example HelloWorld</topic>\n"
"                    </topics>\n"
"                    <data_tags>\n"
"                        <tag>\n"
"                            <name>aTagName1</name>\n"
"                            <value>aTagValue1</value>\n"
"                        </tag>\n"
"                        <tag>\n"
"                            <name>aTagName2</name>\n"
"                            <value>aTagValue2</value>\n"
"                        </tag>\n"
"                    </data_tags>\n"
"                </subscribe>\n"
"            </allow_rule>\n"
"            <!--\n"
"            A default element can be included to define default rules for all\n"
"            domains and topics not explicitly covered by any of the rules in \n"
"            the grant. Accepted values are DENY and ALLOW.\n"
"            -->\n"
"            <default>DENY</default>\n"
"        </grant>\n"
"    </permissions>\n"
"</dds>\n"
"------146BEB6E03BFC9E6ADC53703DC207707\n"
"Content-Type: application/pkcs7-signature; name=\"smime.p7s\"\n"
"Content-Transfer-Encoding: base64\n"
"Content-Disposition: attachment; filename=\"smime.p7s\"\n"
"\n"
"MIIGcwYJKoZIhvcNAQcCoIIGZDCCBmACAQExDTALBglghkgBZQMEAgEwCwYJKoZI\n"
"hvcNAQcBoIIDkjCCA44wggJ2AgkA+U34hoRC6h8wDQYJKoZIhvcNAQELBQAwgYgx\n"
"CzAJBgNVBAYTAlVTMQswCQYDVQQIDAJDQTESMBAGA1UEBwwJU3Vubnl2YWxlMRgw\n"
"FgYDVQQKDA9NeSBPcmdhbml6YXRpb24xEjAQBgNVBAMMCU15IE9yZyBDQTEqMCgG\n"
"CSqGSIb3DQEJARYbZXhhbXBsZUBteS1vcmdhbml6YXRpb24uY29tMB4XDTE5MDkx\n"
"MDIwMzkzNloXDTI5MDkwNzIwMzkzNlowgYgxCzAJBgNVBAYTAlVTMQswCQYDVQQI\n"
"DAJDQTESMBAGA1UEBwwJU3Vubnl2YWxlMRgwFgYDVQQKDA9NeSBPcmdhbml6YXRp\n"
"b24xEjAQBgNVBAMMCU15IE9yZyBDQTEqMCgGCSqGSIb3DQEJARYbZXhhbXBsZUBt\n"
"eS1vcmdhbml6YXRpb24uY29tMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKC\n"
"AQEA3cpjKEWWGDx6meR3QXbt4SknbxFkwikj9wxvJIIR/CHtdVNQrOB7PlFphIv6\n"
"8+7gfewM+YXPPLrychcr882V9xUfhu50Hwe5qX7hNRTOREVSs5Ahbi1/HVWc9Ifv\n"
"PDa1rEFUgg/RdFrGjQRP7+6EF8Ii33U26aIt21hFesvLGeQSCfwWat8fx02XBY79\n"
"1r9HwBSDMTbKaJdXl1uKp5pzT0ARrzEsi3Hd3zcC1V5Ls2WMQPwg8pkn5xaTC1bR\n"
"SnktKd16zOZp4ZXyyS94HyuHcZjRtwAiJqKQFwHxUSWQ53DQZA1GPkmae08j7EQe\n"
"dGbL5DgGXWyfANujFOWIX81ObQIDAQABMA0GCSqGSIb3DQEBCwUAA4IBAQB0QdEW\n"
"x0kNy7TsZYYv//409freOlA2sF+Iw9k/IO/anXwEue34nVgjd7ZiG4q7wIgvANIJ\n"
"e6QzdR0+K2g0SveErC/bBRabwbaGFpsRrJsgJUOpOY8056s5RcIHzzq9r71Rutzk\n"
"F12rD7cyjW/el6qrVPBzxSNjXiwyNVzbrSTh+RIybDrpFebf9I4ekEAeIXhWGT68\n"
"JVqgn8TBgkFPfw3PaEGn06ysSxW6i1FEviLSVjQxI3LvInbRZ+NTkJWArm2GGTfY\n"
"p2hoc+NrL+dLCtNzoK7i7k2easf6r8nz8436yu11oMWWGgZFNZlYM3h9UwZFV75o\n"
"UQRXO6dUXAKNSRUxMYICpzCCAqMCAQEwgZYwgYgxCzAJBgNVBAYTAlVTMQswCQYD\n"
"VQQIDAJDQTESMBAGA1UEBwwJU3Vubnl2YWxlMRgwFgYDVQQKDA9NeSBPcmdhbml6\n"
"YXRpb24xEjAQBgNVBAMMCU15IE9yZyBDQTEqMCgGCSqGSIb3DQEJARYbZXhhbXBs\n"
"ZUBteS1vcmdhbml6YXRpb24uY29tAgkA+U34hoRC6h8wCwYJYIZIAWUDBAIBoIHk\n"
"MBgGCSqGSIb3DQEJAzELBgkqhkiG9w0BBwEwHAYJKoZIhvcNAQkFMQ8XDTE5MDkx\n"
"MDIwMzkzNlowLwYJKoZIhvcNAQkEMSIEIMMhA0WEr2gPQYye+dqMnm/B2KzV6RNq\n"
"y5K6d+hmmbVMMHkGCSqGSIb3DQEJDzFsMGowCwYJYIZIAWUDBAEqMAsGCWCGSAFl\n"
"AwQBFjALBglghkgBZQMEAQIwCgYIKoZIhvcNAwcwDgYIKoZIhvcNAwICAgCAMA0G\n"
"CCqGSIb3DQMCAgFAMAcGBSsOAwIHMA0GCCqGSIb3DQMCAgEoMA0GCSqGSIb3DQEB\n"
"AQUABIIBALfklRpzX+yqb/BCmC2LI1KoY1Fzrui875bDKXMMlx1TwZ0J6KH3t9dl\n"
"5AR7AP7troWhO/IzWuFZtZa8sMYiDayV4rPOlKd/zUmtXO2WMJ0uLoziML3bhtbk\n"
"qBAKidy7LpTr5za3g4TODGdMm4XvWknY5AYSbVJje84SyTyPW4SKCeKd0qFIUDsB\n"
"UuYPXRWjKKV6kib4ah99WzobLgo7zKGLnk9qBt4l73pkKNOWZqzHtsbKuvuT0+Db\n"
"g5QjZt6tbnDguopZFokdoi/cK9zG/allalFaBIJB4Tk20nit7dHGDX+Q2uZD8J+C\n"
"TyE18LTDAf/0BYb1CnI66vucoUD33aA=\n"
"\n"
"------146BEB6E03BFC9E6ADC53703DC207707--\n";

ApplicationSecMaterial::ApplicationSecMaterial()
{
    this->ca_id_cert = NULL;
    this->ca_perm_cert = NULL;
    this->peer_key = NULL;
    this->peer_cert = NULL;
    this->xml_gov = NULL;
    this->xml_perm = NULL;
}

ApplicationSecMaterial::ApplicationSecMaterial(const char *ca_id_cert,
        const char *ca_perm_cert,
        const char *peer_key,
        const char *peer_cert,
        const char *xml_gov,
        const char *xml_perm)
{
    this->ca_id_cert = ca_id_cert;
    this->ca_perm_cert = ca_perm_cert;
    this->peer_key = peer_key;
    this->peer_cert = peer_cert;
    this->xml_gov = xml_gov;
    this->xml_perm = xml_perm;
}

ApplicationSecMaterial::~ApplicationSecMaterial()
{

}


#define ApplicationSecMaterial_print_var(k_,v_) \
    printf("# %-18s : %s\n",(k_), (v_))

    void
ApplicationSecMaterial::print()
{
    // Uncomment these lines to print configuration
    // ApplicationSecMaterial_print_var("Identity CA,", this->ca_id_cert);
    // ApplicationSecMaterial_print_var("Permissions CA,", this->ca_perm_cert);
    // ApplicationSecMaterial_print_var("PEER certificate",this->peer_cert);
    // ApplicationSecMaterial_print_var("PEER key",        this->peer_key);
    // ApplicationSecMaterial_print_var("XML governance",  this->xml_gov);
    // ApplicationSecMaterial_print_var("XML permissions", this->xml_perm);
}

    bool
ApplicationSecMaterial::is_valid()
{
    return this->ca_id_cert != NULL &&
        this->ca_perm_cert != NULL &&
        this->peer_key != NULL &&
        this->peer_cert != NULL &&
        this->xml_gov != NULL &&
        this->xml_perm != NULL;
}


    void
Application::help(char *appname)
{
#define HELP_FMT "%-24s - %s"

    printf("%s [options]\n", appname);
    printf("options:\n");
    printf(HELP_FMT,"-h","This text\n");
    printf(HELP_FMT,"-domain <id>","DomainId (default: 0)\n");
    printf(HELP_FMT,"-udp_intf <intf>","udp interface (no default)\n");
    printf(HELP_FMT,"-peer <address>","peer address (no default)\n");
    printf(HELP_FMT,"-count <count>","count (default -1)\n");
    printf(HELP_FMT,"-sleep <ms>","sleep between sends (default 1s)\n");
    printf(HELP_FMT" (default: %s)\n", "-ca-id <ca.pem>",
            "URL of Identity Certificate Authority's certificate",
            PEER_MATERIAL_DEFAULT.ca_id_cert);
    printf(HELP_FMT" (default: %s)\n", "-ca-perm <ca.pem>",
            "URL of Permissions Certificate Authority's certificate",
            PEER_MATERIAL_DEFAULT.ca_perm_cert);
    printf(HELP_FMT" (default: %s)\n", "-key <peer_key.pem>",
            "URL of DomainParticipants's private key",
            PEER_MATERIAL_DEFAULT.peer_key);
    printf(HELP_FMT" (default: %s)\n", "-cert <peer.pem>",
            "URL of DomainParticipants's certificate",
            PEER_MATERIAL_DEFAULT.peer_cert);
    printf(HELP_FMT" (default: %s)\n", "-gov <governance.p7s>",
            "URL of signed XML governance file",
            PEER_MATERIAL_DEFAULT.xml_gov);
    printf(HELP_FMT" (default: %s)\n", "-perm <permissions.p7s>",
            "URL of signed XML permissions file",
            PEER_MATERIAL_DEFAULT.xml_perm);
    printf("\n");
}

    DDS_ReturnCode_t
Application::configure_security(
        RTRegistry *registry,
        DDS_DomainParticipantQos &dp_qos,
        ApplicationSecMaterial *sec_material)
{
    DDS_ReturnCode_t retval = DDS_RETCODE_ERROR;
    /* Properties to register built-in security plugins */
    SECCORE_SecurePluginFactoryProperty sec_plugin_prop;

    this->sec_material = sec_material;

    /* Create property values from peer name */
    if (this->sec_material == NULL || !this->sec_material->is_valid())
    {
        printf("invalid security configuration\n");
        goto done;
    }

    this->sec_material->print();

    /* Register factories for built-in security plugins, using default
     * properties and default name */
    if (!SECCORE_SecurePluginFactory::register_suite(
                registry,SECCORE_DEFAULT_SUITE_NAME,sec_plugin_prop))
    {
        printf("failed to register security plugins\n");
        goto done;
    }

    /* In order to enable security, the name used to register the suite of
     * plugins must be set in DomainParticipantQos */
    if (!dp_qos.trust.suite.set_name(SECCORE_DEFAULT_SUITE_NAME))
    {
        printf("failed to set component id\n");
        goto done;
    }

    /* X509 Certificate of the Identity CA */
    if (!dp_qos.property.value.assert_property(
                DDS_SECURITY_IDENTITY_CA_PROPERTY,
                this->sec_material->ca_id_cert, RTI_FALSE))
    {
        printf ("failed to assert property %s\n",
                DDS_SECURITY_IDENTITY_CA_PROPERTY);
        goto done;
    }

    /* X509 Certificate of the Permissions CA -- in this example we
     * are reusing the same CA for both Identity and Permissions */
    if (!dp_qos.property.value.assert_property(
                DDS_SECURITY_PERMISSIONS_CA_PROPERTY,
                this->sec_material->ca_perm_cert, RTI_FALSE))
    {
        printf ("failed to assert property %s\n",
                DDS_SECURITY_PERMISSIONS_CA_PROPERTY);
        goto done;
    }

    /* Private Key of the DomainParticipant's identity */
    if (!dp_qos.property.value.assert_property(
                DDS_SECURITY_PRIVATE_KEY_PROPERTY,
                this->sec_material->peer_key, RTI_FALSE))
    {
        printf ("failed to assert property %s\n",
                DDS_SECURITY_PRIVATE_KEY_PROPERTY);
        goto done;
    }

    /* Public certificate of the DomainParticipant's identity, signed
     * by the Certificate Authority */
    if (!dp_qos.property.value.assert_property(
                DDS_SECURITY_IDENTITY_CERTIFICATE_PROPERTY,
                this->sec_material->peer_cert, RTI_FALSE))
    {
        printf ("failed to assert property %s\n",
                DDS_SECURITY_IDENTITY_CERTIFICATE_PROPERTY);
        goto done;
    }

    /* XML file containing domain governance configuration, signed by
     * the Permission CA */
    if (!dp_qos.property.value.assert_property(
                DDS_SECURITY_GOVERNANCE_PROPERTY,
                this->sec_material->xml_gov, RTI_FALSE))
    {
        printf ("failed to assert property %s\n",
                DDS_SECURITY_GOVERNANCE_PROPERTY);
        goto done;
    }

    /* XML file containing domain permissions configuration, signed by
     * the Permission CA */
    if (!dp_qos.property.value.assert_property(
                DDS_SECURITY_PERMISSIONS_PROPERTY,
                this->sec_material->xml_perm, RTI_FALSE))
    {
        printf ("failed to assert property %s\n",
                DDS_SECURITY_PERMISSIONS_PROPERTY);
        goto done;
    }

    retval = DDS_RETCODE_OK;

done:

    return retval;
}

    DDS_ReturnCode_t 
Application::initialize(const char *local_participant_name,
        const char *remote_participant_name,
        DDS_Long domain_id,
        char *udp_intf,
        char *peer,
        DDS_Long sleep_time,
        DDS_Long count,
        ApplicationSecMaterial *sec_material)
{
    DDS_ReturnCode_t retcode;
    DDSDomainParticipantFactory *factory = NULL; 
    DDS_DomainParticipantFactoryQos dpf_qos;
    DDS_DomainParticipantQos dp_qos;
    DPDE_DiscoveryPluginProperty dpde_properties;
    DDS_Boolean success = DDS_BOOLEAN_FALSE;
    RTRegistry *registry = NULL;
    UDP_InterfaceFactoryProperty *udp_property = NULL;

    /* Uncomment to increase verbosity level:
       OSAPI_Log_set_verbosity(OSAPI_LOG_VERBOSITY_WARNING);
     */

    this->sleep_time = sleep_time;
    this->count = count;

    factory = DDSDomainParticipantFactory::get_instance();
    registry = factory->get_registry();

    if (!registry->register_component("wh",
                WHSMHistoryFactory::get_interface(),
                NULL, NULL))
    {
        printf("failed to register wh\n");
        goto done;
    }

    if (!registry->register_component("rh",
                RHSMHistoryFactory::get_interface(),
                NULL, NULL))
    {
        printf("failed to register rh\n");
        goto done;
    }

    /* Configure UDP transport's allowed interfaces */
    if (!registry->unregister(NETIO_DEFAULT_UDP_NAME, NULL, NULL))
    {
        printf("failed to unregister udp\n");
        goto done;
    }

    udp_property = new UDP_InterfaceFactoryProperty();
    if (udp_property == NULL)
    {
        printf("failed to allocate udp properties\n");
        goto done;
    }

    /* For additional allowed interface(s), increase maximum and length, and
       set interface below:
     */
    if (!udp_property->allow_interface.maximum(2))
    {
        printf("failed to set allow_interface maximum\n");
        goto done;
    }
    if (!udp_property->allow_interface.length(2))
    {
        printf("failed to set allow_interface length\n");
        goto done;
    }

    /* loopback interface */
#if defined(RTI_DARWIN)
    *udp_property->allow_interface.get_reference(0) = DDS_String_dup("lo0");
#elif defined (RTI_LINUX)
    *udp_property->allow_interface.get_reference(0) = DDS_String_dup("lo");
#elif defined (RTI_VXWORKS)
    *udp_property->allow_interface.get_reference(0) = DDS_String_dup("lo0");
#elif defined(RTI_WIN32)
    *udp_property->allow_interface.get_reference(0) = 
        DDS_String_dup("Loopback Pseudo-Interface 1");
#else
    *udp_property->allow_interface.get_reference(0) = DDS_String_dup("lo");
#endif

    if (udp_intf != NULL)
    { /* use interface supplied on command line */
        *udp_property->allow_interface.get_reference(1) =
            DDS_String_dup(udp_intf);
    }
    else
    {                /* use hardcoded interface */
#if defined(RTI_DARWIN)
        *udp_property->allow_interface.get_reference(1) = 
            DDS_String_dup("en1");
#elif defined (RTI_LINUX)
        *udp_property->allow_interface.get_reference(1) = 
            DDS_String_dup("eth0");
#elif defined (RTI_VXWORKS)
        *udp_property->allow_interface.get_reference(1) = 
            DDS_String_dup("motetsec0");
#elif defined(RTI_WIN32)
        *udp_property->allow_interface.get_reference(1) = 
            DDS_String_dup("Local Area Connection");
#else
        *udp_property->allow_interface.get_reference(1) = 
            DDS_String_dup("ce0");
#endif
    }

    if (!registry->register_component(NETIO_DEFAULT_UDP_NAME,
                UDPInterfaceFactory::get_interface(),
                &udp_property->_parent._parent,
                NULL))
    {
        printf("failed to register udp\n");
        goto done;
    }

    factory->get_qos(dpf_qos);
    dpf_qos.entity_factory.autoenable_created_entities = DDS_BOOLEAN_FALSE;
    factory->set_qos(dpf_qos);

    if (peer == NULL)
    {
        peer = (char *)"127.0.0.1"; /* default to loopback */
    }

    /* In order to speed up mutual detection between participants and trigger
     * the authentication handshake, we reduce the liveliness assertion period
     * in the discovery plugin properties */
    dpde_properties.participant_liveliness_assert_period.sec = 5;

    if (!registry->register_component(
                "dpde",
                DPDEDiscoveryFactory::get_interface(),
                &dpde_properties._parent,
                NULL))
    {
        printf("failed to register dpde\n");
        goto done;
    }

    if (!dp_qos.discovery.discovery.name.set_name("dpde"))
    {
        printf("failed to set discovery plugin name\n");
        goto done;
    }

    dp_qos.discovery.initial_peers.maximum(1);
    dp_qos.discovery.initial_peers.length(1);
    *dp_qos.discovery.initial_peers.get_reference(0) = DDS_String_dup(peer);

    /* if there are more remote or local endpoints, you need to increase these limits */
    dp_qos.resource_limits.max_destination_ports = 32;
    dp_qos.resource_limits.max_receive_ports = 32;
    dp_qos.resource_limits.local_topic_allocation = 1;
    dp_qos.resource_limits.local_type_allocation = 1;
    dp_qos.resource_limits.local_reader_allocation = 1;
    dp_qos.resource_limits.local_writer_allocation = 1;
    dp_qos.resource_limits.remote_participant_allocation = 8;
    dp_qos.resource_limits.remote_reader_allocation = 8;
    dp_qos.resource_limits.remote_writer_allocation = 8;

    dp_qos.property.value.maximum(1);
    dp_qos.property.value.length(1);
    dp_qos.property.value[0].name = DDS_String_dup("cryptography.max_receiver_specific_macs");
    if(!dp_qos.property.value[0].name)
    {
        printf("failed at DDS_String_dup for name\n");
        goto done;
    }
    dp_qos.property.value[0].value = DDS_String_dup("3");
    if(!dp_qos.property.value[0].value)
    {
        printf("failed at DDS_String_dup for value\n");
        goto done;
    }


#ifdef USE_SECURITY
    if (DDS_RETCODE_OK !=
            this->configure_security(registry, dp_qos, sec_material))
    {
        printf("failed to configure security\n");
        goto done;
    }
#endif /* USE_SECURITY */

    this->participant = factory->create_participant(
            (DDS_DomainId_t)domain_id,
            dp_qos, 
            NULL,
            DDS_STATUS_MASK_NONE);

    if (this->participant == NULL)
    {
        printf("failed to create participant\n");
        goto done;
    }

    strcpy(this->type_name,"HelloWorld");

    retcode = HelloWorldTypeSupport::register_type(this->participant,
            this->type_name);
    if (retcode != DDS_RETCODE_OK)
    {
        printf("failed to register type: %s\n", "test_type");
        goto done;
    }

    strcpy(this->topic_name, "Example HelloWorld");
    this->topic = this->participant->create_topic(
            this->topic_name,
            this->type_name,
            DDS_TOPIC_QOS_DEFAULT, 
            NULL,
            DDS_STATUS_MASK_NONE);
    if (this->topic == NULL)
    {
        printf("topic == NULL\n");
        goto done;
    }

    success = DDS_BOOLEAN_TRUE;

done:

    if (!success)
    {
        if (udp_property != NULL)
        {
            delete udp_property;
            udp_property = NULL;
        }
        if(dp_qos.property.value[0].name)
        {   
            DDS_String_free(dp_qos.property.value[0].name);
        }

        if(dp_qos.property.value[0].value)
        {   
            DDS_String_free(dp_qos.property.value[0].value);
        }
    }

    return (success ? DDS_RETCODE_OK : DDS_RETCODE_ERROR);
}

    DDS_ReturnCode_t
Application::enable()
{
    DDS_ReturnCode_t retcode;

    retcode = this->participant->enable();
    if (retcode != DDS_RETCODE_OK)
    {
        printf("failed to enable entity\n");
    }

    return retcode;
}

Application::Application()
{
    this->participant = NULL;
    this->topic = NULL;
    this->topic_name[0] = '\0';
    this->type_name[0] = '\0';
    this->sleep_time = 1000;
    this->count = 0;
}


Application::~Application()
{
    DDS_ReturnCode_t retcode;
    RTRegistry *registry = NULL;
    UDP_InterfaceFactoryProperty *udp_property = NULL;

    if (this->participant != NULL)
    {
        retcode = this->participant->delete_contained_entities();
        if (retcode != DDS_RETCODE_OK)
        {
            printf("failed to delete contained entities (retcode=%d)\n",retcode);
        }

        retcode =
            DDSTheParticipantFactory->delete_participant(this->participant);
        if (retcode != DDS_RETCODE_OK)
        {
            printf("failed to delete participant: %d\n", retcode);
            return;
        }
        this->participant = NULL;
    }

    registry = (DDSDomainParticipantFactory::get_instance())->get_registry();

    if (!registry->unregister(NETIO_DEFAULT_UDP_NAME,
                (RT_ComponentFactoryProperty**)&udp_property, 
                NULL))
    {
        printf("failed to unregister udp\n");
        return;
    }
    if (udp_property != NULL)
    {
        delete udp_property;
        udp_property = NULL;
    }

    if (!SECCORE_SecurePluginFactory::unregister_suite(registry, NULL))
    {
        printf("failed to unregister security plugins\n");
        return;
    }

    if (!registry->unregister("dpde", NULL, NULL))
    {
        printf("failed to unregister dpde\n");
        return;
    }
    if (!registry->unregister("rh", NULL, NULL))
    {
        printf("failed to unregister rh\n");
        return;
    }
    if (!registry->unregister("wh", NULL, NULL))
    {
        printf("failed to unregister wh\n");
        return;
    }

    retcode = DDSTheParticipantFactory->finalize_instance();
    if (retcode != DDS_RETCODE_OK)
    {
        printf("failed to finalize instance (retcode=%d)\n",retcode);
        return;
    }
}
